package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMPRODUCT;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMPRODUCTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMPRODUCT] 服务对象接口
 */
public interface IEAMPRODUCTService extends IService<EAMPRODUCT>{

    boolean create(EAMPRODUCT et) ;
    void createBatch(List<EAMPRODUCT> list) ;
    boolean update(EAMPRODUCT et) ;
    void updateBatch(List<EAMPRODUCT> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMPRODUCT get(String key) ;
    EAMPRODUCT getDraft(EAMPRODUCT et) ;
    boolean checkKey(EAMPRODUCT et) ;
    boolean save(EAMPRODUCT et) ;
    void saveBatch(List<EAMPRODUCT> list) ;
    Page<EAMPRODUCT> searchDefault(EAMPRODUCTSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMPRODUCT> getEamproductByIds(List<String> ids) ;
    List<EAMPRODUCT> getEamproductByEntities(List<EAMPRODUCT> entities) ;
}


